# jDatePicker

jDatePicker offers a different design approach to provide a 'fancy' way of selecting date and time.

## Documentation

The initialization options and further documentation is available here:

[Documentation link](https://intersofts.com/jDatePicker)

## The interface

![](shot1.jpg)
-----------------
<h2>Install</h2>
                <p>In order to use <strong>jDatePicker</strong>, you need to append the following files to your project:</p>
                <h5>Document's head tag</h5>
                <div class="code">
                    &lt;link href="src/jDatePicker.min.css" rel="stylesheet"&gt;
                </div>
                <h5>Document's body tag</h5>
                <div class="code">
                    &lt;script src="src/jDatePicker.min.js"&gt;&lt;/script&gt;
                </div>
                <hr>
                <h2>Usage</h2>
                <p>Once your document DOM finishes loading, you may create one or more instance of jDatePicker:</p>
                <div class="code">
                    const dPicker = new jDatePicker();
                    <br>
                    dPicker.open();
                </div>
                <p>The <strong>open()</strong> method is required to be called in order for the UI to be displayed to the user.</p>
                <hr>
                <h2>Options</h2>
                <p>
                    <strong>jDatePicker</strong> provides an array of options to help you integrate it into your project. Options must be declared whenever 
                    you create a new instance of jDatePicker, as described below:
                </p>
                <ul class="option-listing">
                    <li>
                        <h4>year:number (optional)</h4>
                        <p>Pre-selects the year.</p>
                    </li>
                    <li>
                        <h4>month:number (optional)</h4>
                        <p>Pre-selects the month.</p>
                    </li>
                    <li>
                        <h4>date:number (optional)</h4>
                        <p>Pre-selects the date.</p>
                    </li>
                    <li>
                        <h4>hour:number (optional)</h4>
                        <p>Pre-selects the hour. Default: current client time.</p>
                    </li>
                    <li>
                        <h4>minute:number (optional)</h4>
                        <p>Pre-selects the minutes. Default: current client time.</p>
                    </li>
                    <li>
                        <h4>disableDates:array (optional)</h4>
                        <p>Prevent provided dates from been selected. Expects and array containing date objects, as displayed below.</p>
                        <br>
                        <pre class="code">
...
disableDates: [
&nbsp; date: 25,
&nbsp; month: 12,
&nbsp; year: 2022
]
...
                        </pre>
                    </li>
                    <li>
                        <h4>enableYearChange:boolean (optional)</h4>
                        <p>Enable or disables the controls to change year. Default: true.</p>
                    </li>
                    <li>
                        <h4>enableMonthChange:boolean (optional)</h4>
                        <p>Enable or disables the controls to change month. Default: true.</p>
                    </li>
                    <li>
                        <h4>enableTimeChange (optional)</h4>
                        <p>Enable or disables the controls to change time. Default: true.</p>
                    </li>
                    <li>
                        <h4>translation:array (optional)</h4>
                        <p>Allows the UI to be translated to any language supported by the font. Default: English.</p>
                        <br>
                        <pre class="code">
...
translation: {
    month: ['January', 'February', 'March', 'April', 'May', 'June', 'July', 'August', 'September', 'October', 'November', 'Dezember'],
    week: ['sun', 'mon', 'tue', 'wed', 'thu', 'fri', 'sat']
}
...                            
                        </pre>
                    </li>
                    <li>
                        <h4>holidays:array (optional)</h4>
                        <p>Highlights the calendar's using the dates provided within the array.</p>
                        <br>
                        <pre class="code">
...
holidays: [
    {
        date: 25,
        month: 12,
        name: 'Christmas'
    },
    {
        date: 1,
        month: 9,
        name: 'Saint J'
    }
]
...
                        </pre>
                    </li>
                    <li>
                        <h4>onDate:callback (optional)</h4>
                        <p>Callback triggered every time the date changes.</p>
                    </li>
                    <li>
                        <h4>onMonth:callback (optional)</h4>
                        <p>Callback triggered every time the month changes.</p>
                    </li>
                    <li>
                        <h4>onYear:callback (optional)</h4>
                        <p>Callback triggered every time the year changes.</p>
                    </li>
                    <li>
                        <h4>onCancel:callback (optional)</h4>
                        <p>Callback triggered when user clicks the close button within jDatePicker.</p>
                    </li>
                    <li>
                        <h4>onAccept:callback (optional)</h4>
                        <p>Callback triggered when user clicks the accept button within jDatePicker.</p>
                    </li>
                    <li>
                        <h4>Callbacks</h4>
                        <p>All available callbacks must be declared within the option payload.</p>
                        <br>
                        <pre class="code">
... 
onDate: () => {},
onMonth: () => {},
onYear: () => {},
onTime: () => {},
onCancel: () => {},
onAccept: () => {}
...
                        </pre>
                    </li>
                </ul>
                <hr>
                <h2>License</h2>
                <p>This software is provided to you free of charge under <strong>CC BY 4.0</strong> license.</p>
                <p><a href="https://creativecommons.org/licenses/by/4.0/" target="_blank">&raquo; Read license terms here.</a></p>
                <hr>
                <h2>Notice</h2>
                THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
            </div>