/**
 * @class jDatePicker
 * @version 1.0.4
 * @author J. Taniguchi <https://intersofts.com>
 * @license CC https://creativecommons.org/licenses/by/4.0/
 */
class jDatePicker{constructor(t){this.OPTIONS=this._validateOptions(t),this.UI={iconLeft:'<svg xmlns="http://www.w3.org/2000/svg" width="20" height="20" viewBox="0 0 24 24" fill="none" stroke="#666" stroke-width="2.5" stroke-linecap="round" stroke-linejoin="round"><polyline points="11 17 6 12 11 7"></polyline><polyline points="18 17 13 12 18 7"></polyline></svg>',iconRight:'<svg xmlns="http://www.w3.org/2000/svg" width="20" height="20" viewBox="0 0 24 24" fill="none" stroke="#666" stroke-width="2.5" stroke-linecap="round" stroke-linejoin="round"><polyline points="13 17 18 12 13 7"></polyline><polyline points="6 17 11 12 6 7"></polyline></svg>',iconClose:'<svg xmlns="http://www.w3.org/2000/svg" width="20" height="20" viewBox="0 0 24 24" fill="none" stroke="#fff" stroke-width="2.5" stroke-linecap="round" stroke-linejoin="round"><line x1="18" y1="6" x2="6" y2="18"></line><line x1="6" y1="6" x2="18" y2="18"></line></svg>',iconCheck:'<svg xmlns="http://www.w3.org/2000/svg" width="20" height="20" viewBox="0 0 24 24" fill="none" stroke="#fff" stroke-width="2.5" stroke-linecap="round" stroke-linejoin="round"><polyline points="20 6 9 17 4 12"></polyline></svg>',iconPlus:'<svg xmlns="http://www.w3.org/2000/svg" width="20" height="20" viewBox="0 0 24 24" fill="none" stroke="#d1d1d1" stroke-width="2.5" stroke-linecap="round" stroke-linejoin="round"><line x1="12" y1="5" x2="12" y2="19"></line><line x1="5" y1="12" x2="19" y2="12"></line></svg>',iconMinus:'<svg xmlns="http://www.w3.org/2000/svg" width="20" height="20" viewBox="0 0 24 24" fill="none" stroke="#d1d1d1" stroke-width="2.5" stroke-linecap="round" stroke-linejoin="round"><line x1="5" y1="12" x2="19" y2="12"></line></svg>'}}open(){this._renderUi(),this._renderMonth()}_renderUi(){const t=this;this.UI.wrap=document.createElement("div"),this.UI.box=document.createElement("div"),this.UI.calendarWrap=document.createElement("div"),this.UI.year={wrap:document.createElement("div"),title:document.createElement("div"),label:document.createElement("label"),previousBtn:document.createElement("button"),nextBtn:document.createElement("button")},this.UI.month={wrap:document.createElement("div"),title:document.createElement("label"),previousBtn:document.createElement("button"),nextBtn:document.createElement("button")},this.UI.date=document.createElement("p"),this.UI.clock={wrap:document.createElement("div"),hour:document.createElement("p"),minute:document.createElement("p"),semi:document.createElement("div"),hourPlusBtn:document.createElement("button"),hourMinusBtn:document.createElement("button"),minutePlusBtn:document.createElement("button"),minuteMinusBtn:document.createElement("button")},this.UI.acceptBtn=document.createElement("button"),this.UI.cancelBtn=document.createElement("button"),this.UI.wrap.id="jdatepicker",this.UI.box.id="jdatepicker-box",this.UI.calendarWrap.id="jdatepicker-calendar__wrap",this.UI.year.wrap.className="jdatepicker-calendar--yearwrap",this.UI.year.title.className="jdatepicker-calendar--yeartitle",this.UI.month.wrap.className="jdatepicker-calendar--monthwrap",this.UI.date.className="jdatepicker-calendar--datelabel",this.UI.clock.wrap.className="jdatepicker-clock",this.UI.acceptBtn.id="jdatepicker-clock--accept",this.UI.acceptBtn.className="jdatepicker-controlbtn",this.UI.cancelBtn.id="jdatepicker-clock--cancel",this.UI.cancelBtn.className="jdatepicker-controlbtn",this.UI.clock.hour.id="jdatepicker-clock--hour",this.UI.clock.hour.className="jdatepicker-clock--p",this.UI.clock.minute.id="jdatepicker-clock--minute",this.UI.clock.minute.className="jdatepicker-clock--p",this.UI.clock.semi.id="jdatepicker-clock--semi",this.UI.clock.semi.className="jdatepicker-clock--p",this.OPTIONS.enableTimeChange&&(this.UI.clock.hourPlusBtn.id="jdatepicker-clock-hplus",this.UI.clock.hourPlusBtn.className="jdatepicker-clock--btn",this.UI.clock.hourMinusBtn.id="jdatepicker-clock-hminus",this.UI.clock.hourMinusBtn.className="jdatepicker-clock--btn",this.UI.clock.minutePlusBtn.id="jdatepicker-clock-mplus",this.UI.clock.minutePlusBtn.className="jdatepicker-clock--btn",this.UI.clock.minuteMinusBtn.id="jdatepicker-clock-mminus",this.UI.clock.minuteMinusBtn.className="jdatepicker-clock--btn"),this.UI.wrap.appendChild(this.UI.box),this.UI.box.appendChild(this.UI.calendarWrap),this.UI.calendarWrap.appendChild(this.UI.year.wrap),this.UI.year.wrap.appendChild(this.UI.year.title),this.OPTIONS.enableYearChange&&this.UI.year.title.appendChild(this.UI.year.previousBtn),this.UI.year.title.appendChild(this.UI.year.label),this.OPTIONS.enableYearChange&&this.UI.year.title.appendChild(this.UI.year.nextBtn),this.UI.year.wrap.appendChild(this.UI.month.wrap),this.OPTIONS.enableMonthChange&&this.UI.month.wrap.appendChild(this.UI.month.previousBtn),this.UI.month.wrap.appendChild(this.UI.month.title),this.OPTIONS.enableMonthChange&&this.UI.month.wrap.appendChild(this.UI.month.nextBtn),this.UI.year.wrap.appendChild(this.UI.date),this.UI.box.appendChild(this.UI.clock.wrap),this.UI.box.appendChild(this.UI.acceptBtn),this.UI.box.appendChild(this.UI.cancelBtn),this.UI.clock.wrap.appendChild(this.UI.clock.hour),this.UI.clock.wrap.appendChild(this.UI.clock.minute),this.UI.clock.wrap.appendChild(this.UI.clock.semi),this.OPTIONS.enableTimeChange&&(this.UI.clock.wrap.appendChild(this.UI.clock.hourPlusBtn),this.UI.clock.wrap.appendChild(this.UI.clock.hourMinusBtn),this.UI.clock.wrap.appendChild(this.UI.clock.minutePlusBtn),this.UI.clock.wrap.appendChild(this.UI.clock.minuteMinusBtn)),this.UI.year.label.innerHTML=this.OPTIONS.year,this.OPTIONS.enableYearChange&&(this.UI.year.previousBtn.innerHTML=this.UI.iconLeft,this.UI.year.nextBtn.innerHTML=this.UI.iconRight),this.UI.month.previousBtn.innerHTML=this.UI.iconLeft,this.OPTIONS.enableMonthChange&&(this.UI.month.nextBtn.innerHTML=this.UI.iconRight,this.UI.month.title.innerHTML=this.OPTIONS.translation.month[this.OPTIONS.month-1]),this.UI.acceptBtn.innerHTML=this.UI.iconCheck,this.UI.cancelBtn.innerHTML=this.UI.iconClose,this.UI.clock.hour.innerHTML=this.OPTIONS.hour<10?`0${this.OPTIONS.hour}`:this.OPTIONS.hour,this.UI.clock.minute.innerHTML=this.OPTIONS.minute<10?`0${this.OPTIONS.minute}`:this.OPTIONS.minute,this.UI.clock.semi.innerHTML=":",this.OPTIONS.enableTimeChange&&(this.UI.clock.hourPlusBtn.innerHTML=this.UI.iconPlus,this.UI.clock.hourMinusBtn.innerHTML=this.UI.iconMinus,this.UI.clock.minutePlusBtn.innerHTML=this.UI.iconPlus,this.UI.clock.minuteMinusBtn.innerHTML=this.UI.iconMinus),document.body.appendChild(this.UI.wrap),this.OPTIONS.enableYearChange&&(this.UI.year.previousBtn.addEventListener("click",e=>{e.preventDefault(),e.stopImmediatePropagation();let n=t.OPTIONS.year-1;n<1900&&(n=1900),t.OPTIONS.onYear(n),t.OPTIONS.year=n,t._handleYearChange()}),this.UI.year.nextBtn.addEventListener("click",e=>{e.preventDefault(),e.stopImmediatePropagation();let n=t.OPTIONS.year+1;t.OPTIONS.onYear(n),t.OPTIONS.year=n,t._handleYearChange()})),this.OPTIONS.enableMonthChange&&(this.UI.month.previousBtn.addEventListener("click",e=>{e.preventDefault(),e.stopImmediatePropagation();let n=t.OPTIONS.month-1;t.OPTIONS.month=n,n<1&&(n=12),t.OPTIONS.onMonth(n),t._handleMonthChange()}),this.UI.month.nextBtn.addEventListener("click",e=>{e.preventDefault(),e.stopImmediatePropagation();let n=t.OPTIONS.month+1;t.OPTIONS.month=n,n>12&&(n=1),t.OPTIONS.onMonth(n),t._handleMonthChange()})),this.UI.cancelBtn.addEventListener("click",e=>{e.preventDefault(),e.stopImmediatePropagation(),t.OPTIONS.onCancel(),t.UI.wrap.remove()}),this.UI.acceptBtn.addEventListener("click",e=>{e.preventDefault(),e.stopImmediatePropagation(),t.OPTIONS.onAccept({date:t.OPTIONS.date,month:t.OPTIONS.month,year:t.OPTIONS.year,hour:t.OPTIONS.hour,minute:t.OPTIONS.minute}),t.UI.wrap.remove()}),this.OPTIONS.enableTimeChange&&(this.UI.clock.hourPlusBtn.addEventListener("click",e=>{e.preventDefault(),e.stopImmediatePropagation(),t.OPTIONS.hour+=1,t.OPTIONS.hour>23&&(t.OPTIONS.hour=0),t.UI.clock.hour.innerHTML=t.OPTIONS.hour<10?`0${t.OPTIONS.hour}`:t.OPTIONS.hour,t.OPTIONS.onTime({hour:t.OPTIONS.hour,minute:t.OPTIONS.minute})}),this.UI.clock.hourMinusBtn.addEventListener("click",e=>{e.preventDefault(),e.stopImmediatePropagation(),t.OPTIONS.hour-=1,t.OPTIONS.hour<0&&(t.OPTIONS.hour=23),t.UI.clock.hour.innerHTML=t.OPTIONS.hour<10?`0${t.OPTIONS.hour}`:t.OPTIONS.hour,t.OPTIONS.onTime({hour:t.OPTIONS.hour,minute:t.OPTIONS.minute})}),this.UI.clock.minutePlusBtn.addEventListener("click",e=>{e.preventDefault(),e.stopImmediatePropagation(),t.OPTIONS.minute+=1,t.OPTIONS.minute>59&&(t.OPTIONS.minute=0),t.UI.clock.minute.innerHTML=t.OPTIONS.minute<10?`0${t.OPTIONS.minute}`:t.OPTIONS.minute,t.OPTIONS.onTime({hour:t.OPTIONS.hour,minute:t.OPTIONS.minute})}),this.UI.clock.minuteMinusBtn.addEventListener("click",e=>{e.preventDefault(),e.stopImmediatePropagation(),t.OPTIONS.minute-=1,t.OPTIONS.minute<0&&(t.OPTIONS.minute=59),t.UI.clock.minute.innerHTML=t.OPTIONS.minute<10?`0${t.OPTIONS.minute}`:t.OPTIONS.minute,t.OPTIONS.onTime({hour:t.OPTIONS.hour,minute:t.OPTIONS.minute})}))}_handleMonthChange(){let t=this.OPTIONS.month-1;t<0&&(t=11,this.OPTIONS.month=t+1),t>11&&(t=0,this.OPTIONS.month=t+1);let e=this._getLastDayOfMonth(this.OPTIONS.year,this.OPTIONS.month);if(this.OPTIONS.date>e){const t=this.UI.dates;let e,n;for(e=0;e<t.length;e++)if(1===(n=parseInt(t[e].getAttribute("data-date")))){t[e].dispatchEvent(new Event("click"));break}}this.UI.month.title.innerHTML=this.OPTIONS.translation.month[t],this._clearWheelDates(),this._renderMonth()}_handleYearChange(){this.UI.year.label.innerHTML=this.OPTIONS.year,this._clearWheelDates(),this._renderMonth();let t=this._getLastDayOfMonth(this.OPTIONS.year,this.OPTIONS.month);if(this.OPTIONS.date>t){const t=this.UI.dates;let e,n;for(e=0;e<t.length;e++)if(1===(n=parseInt(t[e].getAttribute("data-date")))){t[e].dispatchEvent(new Event("click"));break}}}_renderMonth(){const t=this._getLastDayOfMonth(this.OPTIONS.year,this.OPTIONS.month),e=new Date,n=this;let i,a,s,h,o,r,l,c,O,d;for(o=290,r=360/t,c=145,l=3,this.UI.dates=[],i=1;i<=t;i++){for((s=document.createElement("div")).innerHTML=i,s.className="jdatepicker-calendar--button",s.style.height="145px",s.style.transformOrigin="0 100%",s.style.transform=`rotate(${l}deg)`,s.style.left+="50%",s.setAttribute("data-date",i),s.setAttribute("data-month",this.OPTIONS.month),s.setAttribute("data-year",this.OPTIONS.year),this.UI.dates.push(s),e.getUTCDate()===i&&this.OPTIONS.year===e.getUTCFullYear()&&this.OPTIONS.month===e.getUTCMonth()+1&&s.classList.add("today"),O=new Date(`${this.OPTIONS.month}/${i}/${this.OPTIONS.year}`),(h=document.createElement("div")).innerHTML=this.OPTIONS.translation.week[O.getDay()],s.appendChild(h),s.setAttribute("data-week",this.OPTIONS.translation.week[O.getDay()]),this.UI.calendarWrap.appendChild(s),l+=r,a=0;a<this.OPTIONS.holidays.length;a++)this.OPTIONS.holidays[a].date===i&&this.OPTIONS.month===this.OPTIONS.holidays[a].month&&(s.setAttribute("data-holidaydate",this.OPTIONS.holidays[a].date),s.setAttribute("data-holidaymonth",this.OPTIONS.holidays[a].month),s.setAttribute("title",this.OPTIONS.holidays[a].name),s.classList.add("holiday"));for(a=0;a<this.OPTIONS.disabledDates.length;a++)if(d=!0,this.OPTIONS.disabledDates[a].date===i&&this.OPTIONS.disabledDates[a].month===this.OPTIONS.month&&this.OPTIONS.year===this.OPTIONS.disabledDates[a].year){d=!1;break}d?s.addEventListener("click",t=>{t.preventDefault(),t.stopImmediatePropagation();let e=parseInt(t.currentTarget.getAttribute("data-date")),i=t.currentTarget.getAttribute("data-week");n.OPTIONS.date=e,n.OPTIONS.onDate({date:e,week:i});let s=document.getElementsByClassName("jdatepicker-calendar--button");for(a=0;a<s.length;a++)s[a].classList.remove("selected");t.currentTarget.classList.add("selected"),n.UI.date.innerHTML=`<span>${i}</span> ${e}`}):s.classList.add("disabled"),i===this.OPTIONS.date&&(s.classList.add("selected"),this.UI.date.innerHTML=`<span>${h.innerHTML}</span> ${i}`)}}_clearWheelDates(){let t,e=this.UI.dates.length;for(t=0;t<e;t++)this.UI.dates[t].remove();this.UI.dates=[]}_getLastDayOfMonth(t,e){return new Date(t,e,0).getDate()}_validateOptions(t){this.OPTIONS=t;const e=new Date,n=e.getUTCFullYear(),i={year:n,month:e.getUTCMonth()+1,date:e.getUTCDate(),hour:e.getUTCHours(),minute:e.getUTCMinutes(),disabledDates:[{date:25,month:9,year:2021},{date:1,month:1,year:2022}],enableYearChange:!0,enableMonthChange:!0,enableTimeChange:!0,translation:{month:["January","February","March","April","May","June","July","August","September","October","November","Dezember"],week:["sun","mon","tue","wed","thu","fri","sat"]},holidays:[{date:25,month:12,name:"Christmas"},{date:1,month:9,name:"Saint J"}],onDate:()=>{},onMonth:()=>{},onYear:()=>{},onTime:()=>{},onCancel:()=>{},onAccept:()=>{}};return"object"!=typeof this.OPTIONS?(this.OPTIONS=i,i):(this.OPTIONS.year>1900&&this.OPTIONS.year<n+50&&(i.year=this.OPTIONS.year),this.OPTIONS.month>0&&this.OPTIONS.month<13&&(i.month=this.OPTIONS.month),this.OPTIONS.date>0&&this.OPTIONS.date<32&&(i.date=this.OPTIONS.date),this.OPTIONS.hour>-1&&this.OPTIONS.hour<25&&(i.hour=this.OPTIONS.hour),this.OPTIONS.minute>-1&&this.OPTIONS.minute<60&&(i.minute=this.OPTIONS.minute),"function"==typeof this.OPTIONS.onDate&&(i.onDate=this.OPTIONS.onDate),"function"==typeof this.OPTIONS.onMonth&&(i.onMonth=this.OPTIONS.onMonth),"function"==typeof this.OPTIONS.onYear&&(i.onYear=this.OPTIONS.onYear),"function"==typeof this.OPTIONS.onTime&&(i.onTime=this.OPTIONS.onTime),"function"==typeof this.OPTIONS.onCancel&&(i.onCancel=this.OPTIONS.onCancel),"function"==typeof this.OPTIONS.onAccept&&(i.onAccept=this.OPTIONS.onAccept),"boolean"==typeof this.OPTIONS.enableYearChange&&(i.enableYearChange=this.OPTIONS.enableYearChange),"boolean"==typeof this.OPTIONS.enableMonthChange&&(i.enableMonthChange=this.OPTIONS.enableMonthChange),"boolean"==typeof this.OPTIONS.enableTimeChange&&(i.enableTimeChange=this.OPTIONS.enableTimeChange),"object"==typeof this.OPTIONS.translation&&"object"==typeof this.OPTIONS.translation.week&&"object"==typeof this.OPTIONS.translation.month&&(7===this.OPTIONS.translation.week.length&&(i.translation.week=this.OPTIONS.translation.week),12===this.OPTIONS.translation.month.length&&(i.translation.month=this.OPTIONS.translation.month)),"object"==typeof this.OPTIONS.holidays&&this.OPTIONS.holidays.length>0&&(i.holidays=this.OPTIONS.holidays),"object"==typeof this.OPTIONS.disabledDates&&this.OPTIONS.disabledDates.length>0&&(i.disabledDates=this.OPTIONS.disabledDates),this.OPTIONS=i,this.OPTIONS)}}